#pragma once

#include "Core/PrimeHack/PrimeMod.h"
#include <VideoCommon/OnScreenDisplay.h>

namespace prime {
class Invulnerability : public PrimeMod {
public:
  void run_mod(Game game, Region region) override {}
  bool init_mod(Game game, Region region) override {
    switch (game) {
    case Game::PRIME_1:
      if (region == Region::NTSC_U) {
        add_code_change(0x80186408, 0x3863b6d8);
        add_code_change(0x80186414, 0x3863b6d8);
      }
      else if (region == Region::PAL) {
        add_code_change(0x801866a0, 0x3863f618);
        add_code_change(0x801866ac, 0x3863f618);
      }
      else { // region == Region::NTSC-J
        add_code_change(0x80186F88, 0x3863b958);
        add_code_change(0x80186F94, 0x3863b958);
      }
      break;
    case Game::PRIME_1_GCN:
      if (region == Region::NTSC_U) {
        add_code_change(0x80011d3c, 0x3863d780);
        add_code_change(0x80011d48, 0x3863d780);
      }
      else if (region == Region::PAL) {
        add_code_change(0x80012670, 0x3863f820);
        add_code_change(0x8001267c, 0x3863f820);
      }
      break;
    case Game::PRIME_1_GCN_R1:
      add_code_change(0x80011db8, 0x3863d960);
      add_code_change(0x80011dc4, 0x3863d960);
      break;
    case Game::PRIME_1_GCN_R2:
      add_code_change(0x80012008, 0x3863e800);
      add_code_change(0x80012014, 0x3863e800);
      break;
    case Game::PRIME_2:
      if (region == Region::NTSC_U) {
        add_code_change(0x8014bacc, 0x4800000c);
        add_code_change(0x8014bae4, 0x60000000);
      }
      else if (region == Region::PAL) {
        add_code_change(0x8014d240, 0x4800000c);
        add_code_change(0x8014d258, 0x60000000);
      }
      else {  // region == Region::NTSC-J
        add_code_change(0x8014b0d4, 0x4800000c);
        add_code_change(0x8014b0ec, 0x60000000);
      }
      break;
    case Game::PRIME_2_GCN:
      if (region == Region::NTSC_U) {
        add_code_change(0x8000ec08, 0x3c60803d);
        add_code_change(0x8000ec0c, 0x6063aa28);
        add_code_change(0x8000ec10, 0x4e800020);
      } else if (region == Region::NTSC_J) {
        add_code_change(0x8000f624, 0x3c60803d);
        add_code_change(0x8000f628, 0x6063d9d8);
        add_code_change(0x8000f62c, 0x4e800020);
      } else if (region == Region::PAL) {
        add_code_change(0x8000ec4c, 0x3c60803d);
        add_code_change(0x8000ec50, 0x6063bc48);
        add_code_change(0x8000ec54, 0x4e800020);
      }
    }
    return true;
  }        

  void on_state_change(ModState old_state) override {
    if (GetHackManager()->get_active_game() != Game::PRIME_3) {
      if (mod_state() != old_state)
        OSD::AddMessage(StringFromFormat("Invulnerability: %s", mod_state() == ModState::ENABLED ? "Enabled" : "Disabled"));
    }
  }
};
}
